import { 
  select, 
  csv, 
  scaleLinear, 
  scaleBand, 
  max,
  axisLeft,
  axisBottom
} from 'd3';

const svg=select("svg");
const width=960;
const height=450;

const render=data => {
	const xValue = d=>d.Genre;
  const yValue = d=>d.Global_Sales;
  const margin = {top:50, right:50, bottom:50, left:100};
  const innerWidth = width-margin.left-margin.right;
  const innerHeight = height-margin.top-margin.bottom;
  
  const xScale = scaleBand()
  			.domain(data.map(xValue))
  			.range([0,innerWidth])
  			.padding(0.3);
  
  const yScale = scaleLinear()
  			.domain([max(data,yValue),0])
  			.range([0,innerHeight]);
  
  const g = svg.append("g")
        .attr("transform",`translate(${margin.left},${margin.top})`);
  
  const xAxis = g.append("g")
  			.call(axisBottom(xScale))
  			.attr("transform",`translate(0,${innerHeight})`)
  		 g.append("text")
        .attr("x",700)
  			.attr("y",390)
  			.attr("fill","darkblue")
        .text("Genre");
  
  const yAxis = g.append("g")
  			.call(axisLeft(yScale))
       g.append("text")
        .attr("x",-50)
  			.attr("y",-10)
  			.attr("fill","darkblue")
        .text("Global_Sales");
  			
        g.selectAll("rect")
         .data(data)
         .enter()
         .append("rect")
         .attr("x", d=>xScale(xValue(d)))
         .attr("y", d=>yScale(yValue(d)))
         .attr("height", d=>innerHeight - yScale(yValue(d)))
         .attr("width",45)
         .attr("fill",function(d){
              return "steelblue";})
         .on("mouseover",function(){
            d3.select(this)
              .attr("fill","orange");
        })
         .on("mouseout",function(d){
            d3.select(this)
              .transition()
              .duration(250)
              .attr("fill","steelblue");
        });
  
  
}
  



var data=[{"Genre":1,"Global_Sales":2},{"Genre":3,"Global_Sales":4},{"Genre":5,"Global_Sales":6}];

  render(data);
});
